%define apache_version 1.3.12
%define apache_release 30mdk
%define sysconfdir /etc
%define apachecontent /var/www/html
%define apachebase %{sysconfdir}/httpd
%define apacheroot /var/www
%define apachelogs /var/log/httpd
%define apxs %{_sbindir}/apxs
%define libexecdir %{_libdir}/apache
%define jservconf  %{apachebase}/conf/jserv
%define servletdir %{apacheroot}/servlets
%define classesdir %{apacheroot}/classes
%define jsdkversion 20000624

%define javapath %{_prefix}/jdk-sun1.2.2
%define javabin %{javapath}/bin/
%define javaclass %{javapath}/lib/
%define javacompiler %{javapath}/bin/javac

Source:		%{name}-%{version}.tar.gz
Source1:	http://www.euronet.nl/~pauls/java/servlet/download/classpathx_servlet-%{jsdkversion}.tar.bz2
Source2:	jserv.html
Source3:	jservconf.patch
Patch:		jserv-enable-secret.patch
Patch1:		classpath.diff

Summary:	Servlet engine with support for the leading web server
Name:		ApacheJServ
Version:	1.1.2
Release:	5mdk
URL:		http://java.apache.org/
Copyright:	Apache License
Packager: 	Jean-Michel Dault <jmdault@mandrakesoft.com>
Vendor: 	MandrakeSoft
Distribution:	 Linux-Mandrake
BuildRoot: 	%{_tmppath}/%{name}-%{version}-buildroot
Group:		System/Servers
Provides:	jserv jsdk20
Prefix:		%{_prefix}

Conflicts:	tomcat

Requires: 	apache >= %{apache_version}-%{apache_release}
Requires:	jdk

BuildPreReq: 	apache-devel >= %{apache_version}-%{apache_release}

BuildRequires:  jdk
BuildRequires:	automake     >= 1.4
BuildRequires:	autoconf     >= 2.13
BuildRequires:	libtool      >= 1.3.5
BuildRequires:	mm

%description
Apache JServ is a servlet engine, developed by the 
Java Apache Project <http://java.apache.org/>.

The Apache JServ servlet engine is written in 100pc Java application, and 
listens for servlet requests using the Apache Java protocol (AJp). Typically, 
these requests will originate from the mod_jserv Apache module (DSO included).

This package contains a LGPL'ed implementation of sun's java servlet api 
version 2.0 by Paul Siegmann <http://www.euronet.nl/~pauls/java/servlet/>

%prep
echo %{libexecdir}
rm -rf $RPM_BUILD_ROOT
%setup -a 1 -n %{name}-%{version}

# enable socket authentification
%patch
%patch1 -p0

# final position of GNU JSDK-Classes 
sed 's|@JSDK_CLASSES@|%{classesdir}/servlet-2.0.jar|g' \
    < conf/jserv.properties.in  > conf/jserv.properties.in.new
mv conf/jserv.properties.in.new conf/jserv.properties.in

# do not load module in provided jserv.conf; we do this in httpd.conf
sed 's|@LOAD_OR_NOT@|#|g' \
    < conf/jserv.conf.in  > conf/jserv.conf.in.new
mv conf/jserv.conf.in.new conf/jserv.conf.in

# prepare compilation
aclocal
autoconf 
automake

%build

export CLASSPATH=%{javaclass}
export PATH=%{javabin}:$PATH
perl -pi -e "s|jikes \+P \+Z|%{javacompiler}|g;" \
	classpathx_servlet-%{jsdkversion}/Makefile.config
perl -pi -e "s/^HAVE/#HAVE/g;" \
	classpathx_servlet-%{jsdkversion}/Makefile.config

### jsdk API
make -C classpathx_servlet-%{jsdkversion} jar_2_0
make -C classpathx_servlet-%{jsdkversion}/apidoc
#cd classpathx_servlet-%{jsdkversion}
#make
#cd ..

# copy API-doc
mkdir jsdk-doc
cp classpathx_servlet-%{jsdkversion}/README \
	classpathx_servlet-%{jsdkversion}/AUTHORS \
	classpathx_servlet-%{jsdkversion}/COPYING.LIB \
	jsdk-doc
cp -r classpathx_servlet-%{jsdkversion}/apidoc jsdk-doc


### JSERV


CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=%{_prefix}          \
	--disable-debugging           \
        --enable-EAPI                 \
	--with-apxs=%{apxs}        \
	--with-logdir=%{apachelogs}/jserv       \
	--with-servlets=%{servletdir} \
	--with-JSDK=`pwd`/classpathx_servlet-%{jsdkversion}/servlet-2.0.jar \
	--with-jdk-home=%{javapath}
#	--with-javac=`which jikes`
make

%install
make DESTDIR=$RPM_BUILD_ROOT install

echo "default - change on install `date`" > $RPM_BUILD_ROOT/%{jservconf}/jserv.secret.key
chmod 600 $RPM_BUILD_ROOT/%{jservconf}/jserv.secret.key

# currently disabled
#install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
#install -d $RPM_BUILD_ROOT/etc/profile.d
#install -d $RPM_BUILD_ROOT/etc/logrotate.d
#install -m755 src/scripts/package/rpm/jserv.init      $RPM_BUILD_ROOT/etc/rc.d/init.d/jserv
#install -m755 src/scripts/package/rpm/jserv.sh        $RPM_BUILD_ROOT/etc/profile.d
#install -m644 src/scripts/package/rpm/jserv.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/jserv

### GNU JSDK-classes
install -d ${RPM_BUILD_ROOT}%{classesdir}
install classpathx_servlet-%{jsdkversion}/servlet-2.0.jar ${RPM_BUILD_ROOT}%{classesdir}

patch $RPM_BUILD_ROOT/%{jservconf}/jserv.conf %{SOURCE3}

mkdir -p $RPM_BUILD_ROOT%{apachecontent}/addon-modules/%{name}
install -m 644 %{SOURCE2} \
	$RPM_BUILD_ROOT%{apachecontent}/addon-modules/%{name}/index.html

rm -rf jsdk-doc/apidoc/CVS

%clean
#rm -rf $RPM_BUILD_ROOT

%post

echo "Include conf/jserv/jserv.conf" >> %{apachebase}/conf/httpd.conf

# use fortune + install-date + process-list to create pseudo-random, hardly
# guessable secret key. Use md5sum to create a hash from this, if available:
(%{_prefix}/games/fortune 2>/dev/null ; date ; ps -eal 2>/dev/null)   \
		    | (md5sum 2>/dev/null || cat)   		\
		    > %{jservconf}/jserv.secret.key 
chmod 600 %{jservconf}/jserv.secret.key

#
# determine apache-USER and chown the jserv.secrect.key - file
#
APACHEUSER=`grep "^User[	 ]\+" %{apachebase}/conf/httpd.conf | awk '{print $2}'`
if test ! "x$APACHEUSER" = x ; then
   USERCOMMENT="(which is '$APACHEUSER' ?)"
else
   # assumption:
   APACHEUSER=apache
fi
chown $APACHEUSER %{jservconf}/jserv.secret.key

#
# determine apache-GROUP and allow this group to write to %{apachelogs}
APACHEGROUP=`grep "^Group[	 ]\+" %{apachebase}/conf/httpd.conf | awk '{print $2}'`
if test "x$APACHEGROUP" = x ; then
   APACHEGROUP=apache
fi
chown $APACHEUSER.$APACHEGROUP %{apachelogs}/jserv

#
# Add 'jserv' as an independent service (manual mode)
#/sbin/chkconfig --add jserv
#/etc/rc.d/init.d/jserv start


#
# Search vor JAVA at possible locations and edit wrapper.bin
#
unset JAVABIN
for lookfor in java jre ; do
  for loc in \
    $JAVA_HOME	          \
    $JDK_HOME	          \
    %{javapath} \
    %{_prefix}/local/java       \
    %{_prefix}/local/jdk       \
    %{_prefix}/local/jdk117_v3  \
    %{_prefix}/local/jdk117_v1a
  do
    if test -x "$loc/bin/$lookfor" ; then
       JAVABIN="$loc/bin/$lookfor"
       break
    fi
  done

  if test -z "$JAVABIN" ; then
    for prefix in %{_prefix}/jdk %{_prefix}/jdk- %{_prefix}/local/jdk %{_prefix}/local/jdk- ; do
      for jplatform in 3 2 1 ; do
        for subvers in .9 .8 .7 .6 .5 .4 .3 .2 .1 .0 "" ; do
          if test -x "${prefix}1.$jplatform$subvers/bin/$lookfor" ; then
	     JAVABIN="${prefix}1.$jplatform$subvers/bin/$lookfor"
	     break
	  fi
        done
	if test ! -z "$JAVABIN" ; then break ; fi
      done
      if test ! -z "$JAVABIN" ; then break ; fi
    done
  fi
  if test ! -z "$JAVABIN" ; then break ; fi
done

if test ! -z "$JAVABIN" ; then
   sed "s|^wrapper.bin=.*$|wrapper.bin=$JAVABIN|" \
       < %{jservconf}/jserv.properties \
       > %{jservconf}/jserv.properties.new
   mv %{jservconf}/jserv.properties.new %{jservconf}/jserv.properties
fi

#
# Get Server Port to echo right URL below
#
SERVERPORT=`grep "^Port" %{apachebase}/conf/httpd.conf | \
			head -1 | awk '{print ":" $2}'`
if test "$SERVERPORT" = ":80" ; then
	SERVERPORT=""
fi

#FIXME: make this i18n-aware

if test ! "x$JAVABIN" = x ; then
   echo "using java VM $JAVABIN"
else
   echo "## didn't find java or jre. Please install it and edit the"
   echo "## wrapper.bin property in %{jservconf}/jserv.properties"
fi
echo ""
echo "In order to enable JServ, restart the webserver and try"
echo "		 http://localhost$SERVERPORT/servlets/IsItWorking"
echo "	 	(or  http://localhost$SERVERPORT/servlets/Hello"
echo "	 and"
echo "		 http://localhost$SERVERPORT/jserv/"
echo "-- ENJOY! --"
echo ""

## we hopefully may distribute SUN-jsdk.jar with jserv once ..
echo " | NOTE that this distribution contains a fully functional"
echo " | free jsdk replacement, see <http://www.euronet.nl/~pauls/java/servlet/>."
echo " | If you want to use the SUN-jsdk, replace the servlet-2.0.jar"
echo " | in the wrapper.classpath - line in the file"
echo " |		 %{jservconf}/jserv.properties"
echo " | with the SUN jsdk."
echo " | Get it from <http://java.sun.com/products/servlet/>."
echo " | Only JSDK 2.0 (Java Servlet Development Kit)"
echo " | is supported (_EXACTLY_ 2.0)."
echo ""

echo "Please send comments/suggestions regarding"
echo "this RPM to <jmdault@mandrakesoft.com>."

AESctl update



%preun
# do not remove the configured stuff if we upgrade.
# the $1 argument contains the number of packages _after_ installation.
if [ ! $1 -eq 0 ] ; then
   exit 0
fi

# Remove 'jserv' service (manual mode)
#/etc/rc.d/init.d/jserv stop
#/sbin/chkconfig --del jserv

# remove old logs
/bin/rm -fr %{apachelogs}/jserv/mod_jserv.log
/bin/rm -fr %{apachelogs}/jserv/jserv.log

perl -pi -e "s|Include conf/jserv/jserv.conf\n||g;" \
	%{apachebase}/conf/httpd.conf

%postun
%{_sbindir}/AESctl update


%files
%defattr(-,root,root)
# mmh, we can't give %{prefix}/docs to %doc ..
%doc index.html README docs jsdk-doc

%dir %{apachecontent}/addon-modules/%{name}
%{apachecontent}/addon-modules/%{name}/index.html

%config(noreplace) %{jservconf}/jserv.properties
%config(noreplace) %{jservconf}/zone.properties
%config(noreplace) %{jservconf}/jserv.conf

# these are just for demonstration and thus,
# no %config-files per-se; do not install
# them for the RPM-packet
#%{jservconf}/jserv.properties.default
#%{jservconf}/zone.properties.default
#%{jservconf}/jserv.conf.default

%attr(-,apache,apache) %config(noreplace) %{jservconf}/jserv.secret.key
#%config /etc/rc.d/init.d/jserv
#%config /etc/logrotate.d/jserv
#%config /etc/profile.d/jserv.sh

%{libexecdir}/mod_jserv.so
%{libexecdir}/ApacheJServ.jar

%attr(-,apache,apache) %dir %{classesdir}
%attr(-,apache,apache) %{classesdir}/servlet-2.0.jar

%attr(-,apache,apache) %dir %{servletdir}
%attr(-,apache,apache) %{servletdir}/IsItWorking.java
%attr(-,apache,apache) %{servletdir}/IsItWorking.class
%attr(-,apache,apache) %{servletdir}/Hello.java
%attr(-,apache,apache) %{servletdir}/Hello.class

# we need to have write access here
%attr(-,apache,apache) %dir %{apachelogs}/jserv

%changelog

* Wed Sep 27 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.1.2-5mdk
- Removed junk CVS files

* Fri Sep 08 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.1.2-4mdk
- fixed file ownership, fixed paths

* Thu Aug 31 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.1.2-3mdk
- fix post scripts

* Mon Aug 28 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.1.2-2mdk
- Mandrakize Macroize everything

* Tue Jul 18 2000 Peter Hanecak <hanecak@megaloman.sk>
- synchronized with apache-1.3.12-2 (%%{apacheroot} is /var/www, apache
  istead of nobody, ...)
- BuildPreReq apache-devel (because of apxs)

* Sun Jun 18 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 1.1.2

* Sun May 28 2000 Peter Hanecak <hanecak@megaloman.sk>
- update to 1.1.1 (also some stuff from official 1.1.1-1 spec incorporated)
- %%{hthome}
- use %%{_tmppath} to determine build root
- BuildRequires: mm
- disabled jikes (my jikes build makes segmentation faults :( )

* Sun Feb 13 2000 Peter Hanecak <hanecak@megaloman.sk>
- used 'APXS_CFLAGS=$APXS_UTIL -q CFLAGS' and
  'CFLAGS="$APXS_CFLAGS $RPM_OPT_FLAGS"' to determine build flags
  (because of EAPI)

* Tue Feb  8 2000 Peter Hanecak <hanecak@megaloman.sk>
- RPM_OPT_FLAGS passed to CFLAGS
- build root changed from '/tmp/...' to '/var/tmp/...'
- install process fixed for 'docs/api'

* Tue Dec 28 1999 HZ <zeller@to.com>
 - use BuildRequires to reflect the need for current
   versions of the autoconf/automake suite and a
   recent apache-devel because of a bug in older
   versions of this package.

* Thu Sep 30 1999 HZ <zeller@to.com>
 - Release of 1.1 Beta 1

* Wed Sep 29 1999 Henner Zeller <zeller@to.com>
 - new build scheme (1.1)

* Sun Sep 19 1999 Henner Zeller <zeller@to.com>
 - make it work with the apache-1.3.9 RPM
 - use 'test' instead of '[ ]' in conditionals
 - look for java virtual machine and edit jserv.properties' wrapper.bin

* Fri Sep 17 1999 Henner Zeller <zeller@to.com>
 - added LGPL'ed servlet DK by Paul Siegmann

* Wed Aug 18 1999 Henner Zeller <zeller@to.com>
 - edit httpd.conf automatically

* Sat Jul 24 1999 Henner Zeller <zeller@to.com>
 - update to install JServ 1.0.*

* Thu Nov 05 1998 Ross Golder <rossigee@bigfoot.com>
- updated to use the autoconf build system

* Mon Oct 19 1998 Ross Golder <rossg@cpd.co.uk>
- created from previous work to deploy daily snapshot RPMs

